<?
/**
* StorageVector.class.php
* 
* 
*
* @author		Mark Sievers <msievers@uos.de> 
* @version		$Id: StorageVector.class.php,v 1.1 2004/02/18 10:52:10 msievers Exp $
* @access		public
* @modulegroup	core
* @module			
* @package		studip_core
*/

// +---------------------------------------------------------------------------+
// This file is part of Stud.IP
// StorageVector.class.php
// This class represents a vector of Storage-classes
// Copyright (C) 2004 Mark Sievers <mark_sievers2000@yahoo.de>
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+

class StorageVector {
    var $storage_array;
    
    function StorageVector() {
        $this->storage_array = array();
    }
    
    function add($storage) {
        $this->storage_array[] = $storage;
    }

    function update($storage,$va_number) {
        foreach($this->storage_array as $key=>$val) {
            if ($val->getVeranstaltungsNummer()==$va_number) {
                $allDozent = $storage->getAllDozent();
                foreach($allDozent as $key2=>$val2) {
                    $this->storage_array[$key]->addDozent($val2["name"]);
                }
                $this->storage_array[$key]->setNumbers($this->storage_array[$key]->getNumbers()."/".$storage->getVeranstaltungsNummer());
                $allSeminarSemTree = $storage->getAllSeminarSemTree(); // nicht vorhandenen sem_tree Eintrag hinzufuegen
                $existingSeminarSemTree = $this->storage_array[$key]->getAllSeminarSemTree();    
                foreach($allSeminarSemTree as $key2=>$val2) {   // schaue nach, ob es den Eintrag schon gibt
                    $is_in = FALSE;
                    foreach($existingSeminarSemTree as $key3=>$val3) {
                        if ($val2["sem_tree_name"]==$val3["sem_tree_name"]) {
                            $is_in = TRUE;              // Eintrag vorhanden => nicht hinzufuegen
                        }
                    }
                    if (!$is_in) {
                        $this->storage_array[$key]->addSeminarSemTree($val2["sem_tree_name"]);  // nicht vorhanden => Eintrag hinzufuegen
                    }
                }
            }
        }
    }

    function getNext() {
        $ret = current($this->storage_array);
        next($this->storage_array);
        return $ret;
    }

    function getAll() {
        return $this->storage_array;
    }

    function setVaNumbers() {
        foreach($this->storage_array as $key => $val) {
            $string = "";
            $this->storage_array[$key]->setVeranstaltungsNummer($val->getVeranstaltungsNummer().$val->getNumbers());
            $help = explode("/",$this->storage_array[$key]->getVeranstaltungsNummer());
            $new_ar = array_unique($help);
            foreach ($new_ar as $key2=>$val2) {
                $string .= $val2."/";
            }
            $string = substr($string,0,strlen($string)-1);
            $this->storage_array[$key]->setVeranstaltungsNummer($string);
        }
    }
    
}


?>
